# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free
%define namedversion %{version}-beta1
%define sname httpclient

Name:           hc-httpclient
Version:        4.1
Release:        0.r1041655.1%{?dist}
Epoch:          0
Summary:        HTTPClient components
License:        ASL 2.0
URL:            http://hc.apache.org/
Group:          Development/Libraries/Java
# svn export http://svn.apache.org/repos/asf/httpcomponents/httpclient/tags/4.1-beta1/ hc-httpclient-4.1-beta1 && tar cjf hc-httpclient-4.1-beta1.tar.bz2 hc-httpclient-4.1-beta1
# Exported revision 1041655.
Source0:        hc-httpclient-4.1-beta1.tar.bz2
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         %{name}-no-clover.patch
Patch1:         %{name}-maven-notice-plugin-version.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       hc-httpcore >= 0:4.1
Requires:       ehcache-core >= 0:2.2.0
Requires:       java >= 0:1.6.0
Requires:       jpackage-utils
Requires:       spymemcached >= 0:2.5
BuildRequires:  apache-commons-parent >= 0:9
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  easymock-classextension2
BuildRequires:  ehcache-parent >= 0:2.1
BuildRequires:  ehcache-core >= 0:2.2.0
BuildRequires:  hc-httpcore >= 0:4.1
BuildRequires:  hc-project >= 0:4.1.1
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  junit4 >= 0:4.8.1
BuildRequires:  docbkx
BuildRequires:  felix-maven2
BuildRequires:  maven2 >= 2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-release
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  spymemcached >= 0:2.5
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
Provides:       jakarta-httpcore = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-httpcore < %{epoch}:%{version}-%{release}
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Hyper-Text Transfer Protocol (HTTP) is perhaps the most
significant protocol used on the Internet today. Web services,
network-enabled appliances and the growth of network computing
continue to expand the role of the HTTP protocol beyond
user-driven web browsers, while increasing the number of
applications that require HTTP support.

Although the java.net package provides basic functionality
for accessing resources via HTTP, it doesn't provide the full
flexibility or functionality needed by many applications.
HttpClient seeks to fill this void by providing an efficient,
up-to-date, and feature-rich package implementing the client
side of the most recent HTTP standards and recommendations.

Designed for extension while providing robust support for the
base HTTP protocol, HttpClient may be of interest to anyone
building HTTP-aware client applications such as web browsers,
web service clients, or systems that leverage or extend the
HTTP protocol for distributed communication.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%prep
%setup -q -n hc-httpclient-%{namedversion}
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1

cp -p %{SOURCE1} settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.test.skip=false \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Daggregate=true \
        install javadoc:javadoc

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}/httpcomponents
cp -p httpmime/target/httpmime-%{namedversion}.jar %{buildroot}%{_javadir}/httpcomponents/httpmime-%{version}.jar
%if 0
cp -p %{sname}-cache/target/%{sname}-cache-%{namedversion}.jar %{buildroot}%{_javadir}/httpcomponents/%{sname}-cache-%{version}.jar
%endif
cp -p %{sname}/target/%{sname}-%{namedversion}.jar %{buildroot}%{_javadir}/httpcomponents/%{sname}-%{version}.jar
cp -p %{sname}/target/%{sname}-%{namedversion}-tests.jar %{buildroot}%{_javadir}/httpcomponents/%{sname}-tests-%{version}.jar
%if 0
cp -p %{sname}-osgi/target/org.apache.httpcomponents.httpclient_%{namedversion}.jar %{buildroot}%{_javadir}/httpcomponents/org.apache.httpcomponents.httpclient_%{version}.jar
%endif
(cd %{buildroot}%{_javadir}/httpcomponents && for jar in *-%{version}.jar; do ln -s ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# poms
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.httpcomponents-client.pom
%add_to_maven_depmap org.apache.httpcomponents httpcomponents-client %{namedversion} JPP/httpcomponents client
cp -p httpmime/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.httpcomponents-httpmime.pom
%add_to_maven_depmap org.apache.httpcomponents httpmime %{namedversion} JPP/httpcomponents httpmime
cp -p httpclient/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.httpcomponents-httpclient.pom
%add_to_maven_depmap org.apache.httpcomponents httpclient %{namedversion} JPP/httpcomponents httpclient
%if 0
cp -p httpclient-cache/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.httpcomponents-httpclient-cache.pom
%add_to_maven_depmap org.apache.httpcomponents httpclient-cache %{namedversion} JPP/httpcomponents httplient-cache
%endif

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap 
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/httpcomponents
%{_javadir}*/httpcomponents/httpclient-%{version}.jar
%if 0
%{_javadir}*/httpcomponents/httpclient-cache-%{version}.jar
%{_javadir}*/httpcomponents/httpclient-cache.jar
%endif
%{_javadir}*/httpcomponents/httpclient-tests-%{version}.jar
%{_javadir}*/httpcomponents/httpclient-tests.jar
%{_javadir}*/httpcomponents/httpclient.jar
%{_javadir}*/httpcomponents/httpmime-%{version}.jar
%{_javadir}*/httpcomponents/httpmime.jar
%if 0
%{_javadir}*/httpcomponents/org.apache.httpcomponents.httpclient_4.1.jar
%endif
%{_datadir}/maven2/poms/JPP.httpcomponents-client.pom
%if 0
%{_datadir}/maven2/poms/JPP.httpcomponents-httpclient-cache.pom
%endif
%{_datadir}/maven2/poms/JPP.httpcomponents-httpclient.pom
%{_datadir}/maven2/poms/JPP.httpcomponents-httpmime.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Sat Dec 11 2010 David Walluck <dwalluck@redhat.com> 0:4.1-0.r1041655.1
- JPP-6

* Mon Dec 06 2010 David Walluck <dwalluck@redhat.com> 0:4.1-0.r1041655.0.1
- 4.1-beta1
- temporarily disable httpclient-cache and httpclient-osgi

* Thu Dec 02 2010 David Walluck <dwalluck@redhat.com> 0:4.1-0.r962552.2.1
- update jpp-depmap

* Fri Nov 12 2010 David Walluck <dwalluck@redhat.com> 0:4.1-0.r962552.2
- build for JPP-6

* Sat Sep 18 2010 Ralph Apel <r.apel at r-apel.de> 0:4.1-0.r962552.1
- 4.1 alpha3 SNAPSHOT

* Thu Mar 26 2009 Ralph Apel <r.apel at r-apel.de> 0:4.0-1.jpp5
- 4.0 final

* Mon Feb 02 2009 Ralph Apel <r.apel at r-apel.de> 0:4.0-0.a5.1.jpp5
- 4.0-alpha5
- rename from jakarta-httpcore to hc-httpcore
- Obsolete and Provide jakarta-httpcore
- Include compat symlinks
- Build -niossl library

* Wed May 23 2007 Ralph Apel <r.apel at r-apel.de> 0:4.0-0.a4.1jpp
- Initial build
